## Classes

<dl>
<dt><a href="#IgniteTemplate">IgniteTemplate</a></dt>
<dd><p>The outline of a ignite template. Templates are a blueprint that specify&#39;s
how to construct an element and then can be used to construct the element. Everything
starts with a template.</p>
</dd>
<dt><a href="#div">div</a></dt>
<dd><p>An ignite template that can be used to construct a div element.</p>
</dd>
<dt><a href="#a">a</a></dt>
<dd><p>An ignite template that can be used to construct a hyperlink element.</p>
</dd>
<dt><a href="#input">input</a></dt>
<dd><p>An ignite template that can be used to construct a input element.</p>
</dd>
<dt><a href="#textarea">textarea</a></dt>
<dd><p>An ignite template that can be used to construct a textarea element.</p>
</dd>
<dt><a href="#button">button</a></dt>
<dd><p>An ignite template that can be used to construct a button element.</p>
</dd>
<dt><a href="#h1">h1</a></dt>
<dd><p>An ignite template that can be used to construct a h1 element.</p>
</dd>
<dt><a href="#h2">h2</a></dt>
<dd><p>An ignite template that can be used to construct a h2 element.</p>
</dd>
<dt><a href="#h3">h3</a></dt>
<dd><p>An ignite template that can be used to construct a h3 element.</p>
</dd>
<dt><a href="#h4">h4</a></dt>
<dd><p>An ignite template that can be used to construct a h4 element.</p>
</dd>
<dt><a href="#h5">h5</a></dt>
<dd><p>An ignite template that can be used to construct a h5 element.</p>
</dd>
<dt><a href="#h6">h6</a></dt>
<dd><p>An ignite template that can be used to construct a h6 element.</p>
</dd>
<dt><a href="#hr">hr</a></dt>
<dd><p>An ignite template that can be used to construct a hr element.</p>
</dd>
<dt><a href="#p">p</a></dt>
<dd><p>An ignite template that can be used to construct a p element.</p>
</dd>
<dt><a href="#nav">nav</a></dt>
<dd><p>An ignite template that can be used to construct a nav element.</p>
</dd>
<dt><a href="#ul">ul</a></dt>
<dd><p>An ignite template that can be used to construct a ul element.</p>
</dd>
<dt><a href="#li">li</a></dt>
<dd><p>An ignite template that can be used to construct a li element.</p>
</dd>
<dt><a href="#span">span</a></dt>
<dd><p>An ignite template that can be used to construct a span element.</p>
</dd>
<dt><a href="#small">small</a></dt>
<dd><p>An ignite template that can be used to construct a small element.</p>
</dd>
<dt><a href="#strong">strong</a></dt>
<dd><p>An ignite template that can be used to construct a strong element.</p>
</dd>
<dt><a href="#i">i</a></dt>
<dd><p>An ignite template that can be used to construct an i element.</p>
</dd>
<dt><a href="#table">table</a></dt>
<dd><p>An ignite template that can be used to construct a table element.</p>
</dd>
<dt><a href="#td">td</a></dt>
<dd><p>An ignite template that can be used to construct a td element.</p>
</dd>
<dt><a href="#th">th</a></dt>
<dd><p>An ignite template that can be used to construct a th element.</p>
</dd>
<dt><a href="#tr">tr</a></dt>
<dd><p>An ignite template that can be used to construct a tr element.</p>
</dd>
<dt><a href="#thead">thead</a></dt>
<dd><p>An ignite template that can be used to construct a thead element.</p>
</dd>
<dt><a href="#tbody">tbody</a></dt>
<dd><p>An ignite template that can be used to construct a tbody element.</p>
</dd>
<dt><a href="#br">br</a></dt>
<dd><p>An ignite template that can be used to construct a br element.</p>
</dd>
<dt><a href="#img">img</a></dt>
<dd><p>An ignite template that can be used to construct a img element.</p>
</dd>
<dt><a href="#label">label</a></dt>
<dd><p>An ignite template that can be used to construct a label element.</p>
</dd>
<dt><a href="#select">select</a></dt>
<dd><p>An ignite template that can be used to construct a select element.</p>
</dd>
<dt><a href="#option">option</a></dt>
<dd><p>An ignite template that can be used to construct a option element.</p>
</dd>
<dt><a href="#script">script</a></dt>
<dd><p>An ignite template that can be used to construct a script element.</p>
</dd>
<dt><a href="#form">form</a></dt>
<dd><p>An ignite template that can be used to construct a form element.</p>
</dd>
<dt><a href="#header">header</a></dt>
<dd><p>An ignite template that can be used to construct a header element.</p>
</dd>
<dt><a href="#footer">footer</a></dt>
<dd><p>An ignite template that can be used to construct a footer element.</p>
</dd>
<dt><a href="#progress">progress</a></dt>
<dd><p>An ignite template that can be used to construct a progress element.</p>
</dd>
<dt><a href="#svg">svg</a></dt>
<dd><p>An ignite template that can be used to construct a svg element.</p>
</dd>
<dt><a href="#g">g</a></dt>
<dd><p>An ignite template that can be used to construct a g element.</p>
</dd>
<dt><a href="#path">path</a></dt>
<dd><p>An ignite template that can be used to construct a path element.</p>
</dd>
<dt><a href="#circle">circle</a></dt>
<dd><p>An ignite template that can be used to construct a circle element.</p>
</dd>
<dt><a href="#line">line</a></dt>
<dd><p>An ignite template that can be used to construct a line element.</p>
</dd>
<dt><a href="#text">text</a></dt>
<dd><p>Text is a special template that will construct a text element and automatically update the dom
if it&#39;s content changes.</p>
</dd>
<dt><a href="#html">html</a></dt>
<dd><p>Html is a special template that can construct raw html or properties into the dom and automatically
update the dom if the property changes.</p>
</dd>
<dt><a href="#list">list</a></dt>
<dd><p>A special ignite template that constructs a list of items using a template
that is dynamically created for each item.</p>
</dd>
<dt><a href="#slot">slot</a></dt>
<dd><p>A slot template that mimicks the functionality of a slot element in Web Components. This can
be used to place children of a IgniteElement anywhere in the DOM. Slots don&#39;t actually construct an element,
they simply just place children in place where the slot was used. If classes, styles, or attributes are applied
to the slot they will be applied to the children of the slot.</p>
</dd>
<dt><a href="#pagination">pagination</a></dt>
<dd><p>A pagination is a template that segments a list of items into pages based
on the items, page size, current page.</p>
</dd>
<dt><a href="#pager">pager</a></dt>
<dd><p>A pager is a template that converts pagination information into elements
to form a page selection.</p>
</dd>
<dt><a href="#population">population</a></dt>
<dd><p>An ignite template that can construct a population of items
based on a count.</p>
</dd>
</dl>

<a name="IgniteTemplate"></a>

## IgniteTemplate
The outline of a ignite template. Templates are a blueprint that specify's
how to construct an element and then can be used to construct the element. Everything
starts with a template.

**Kind**: global class  

* [IgniteTemplate](#IgniteTemplate)
    * [`new IgniteTemplate(tagName, children)`](#new_IgniteTemplate_new)
    * [`.class(name, converter)`](#IgniteTemplate+class) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.attribute(name, value, converter)`](#IgniteTemplate+attribute) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.value(value, reflect, converter, live)`](#IgniteTemplate+value) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.prop(name, value, reflect, converter)`](#IgniteTemplate+prop) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.property(name, value, reflect, converter)`](#IgniteTemplate+property) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.variable(name, value, converter)`](#IgniteTemplate+variable) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.reflect(name, target)`](#IgniteTemplate+reflect) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.properties(props)`](#IgniteTemplate+properties) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.innerHTML(value, converter)`](#IgniteTemplate+innerHTML) ⇒
    * [`.innerText(value, converter)`](#IgniteTemplate+innerText) ⇒
    * [`.child(...items)`](#IgniteTemplate+child) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.ref(refCallback)`](#IgniteTemplate+ref) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.on(eventName, eventCallback)`](#IgniteTemplate+on) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onClick(eventCallback)`](#IgniteTemplate+onClick) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onTouch(eventCallback)`](#IgniteTemplate+onTouch) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onBlur(eventCallback)`](#IgniteTemplate+onBlur) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onFocus(eventCallback)`](#IgniteTemplate+onFocus) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onChange(eventCallback)`](#IgniteTemplate+onChange) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onInput(eventCallback)`](#IgniteTemplate+onInput) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onPaste(eventCallback)`](#IgniteTemplate+onPaste) ⇒
    * [`.onEnter(eventCallback)`](#IgniteTemplate+onEnter) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onBackspace(eventCallback)`](#IgniteTemplate+onBackspace) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onResize(eventCallback)`](#IgniteTemplate+onResize) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onIntersect(eventCallback)`](#IgniteTemplate+onIntersect) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.onSeen(eventCallback)`](#IgniteTemplate+onSeen) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.style(name, value, priority, converter)`](#IgniteTemplate+style) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.hide(value, converter)`](#IgniteTemplate+hide) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.invisible(value, converter)`](#IgniteTemplate+invisible) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.show(value, converter)`](#IgniteTemplate+show) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.visible(value, converter)`](#IgniteTemplate+visible) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.id(value, converter)`](#IgniteTemplate+id) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.title(value, converter)`](#IgniteTemplate+title) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.for(value, converter)`](#IgniteTemplate+for) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.role(value, converter)`](#IgniteTemplate+role) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.checked(value, converter)`](#IgniteTemplate+checked) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.disabled(value, converter)`](#IgniteTemplate+disabled) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.readonly(value, converter)`](#IgniteTemplate+readonly) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.type(value, converter)`](#IgniteTemplate+type) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.min(value, converter)`](#IgniteTemplate+min) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.max(value, converter)`](#IgniteTemplate+max) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.step(value, converter)`](#IgniteTemplate+step) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.data(name, value, converter)`](#IgniteTemplate+data) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.src(value, converter)`](#IgniteTemplate+src) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.href(value, converter)`](#IgniteTemplate+href) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.target(value, converter)`](#IgniteTemplate+target) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.name(value, converter)`](#IgniteTemplate+name) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.placeholder(value, converter)`](#IgniteTemplate+placeholder) ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
    * [`.construct(parent, sibling)`](#IgniteTemplate+construct)
    * [`.deconstruct()`](#IgniteTemplate+deconstruct)

<a name="new_IgniteTemplate_new"></a>

### `new IgniteTemplate(tagName, children)`
Creates a new IgniteTemplate with the tag name of the element that will be constructed and an
array of child elements.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>tagName</td><td><code>String</code></td><td><code></code></td><td><p>The tag name of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><code></code></td><td><p>An array of child elements to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
//You can easily create a template to construct any html element. See the following:
class div extends IgniteTemplate {
 constructor(...items) {
     super("div", items);
 }
}
```
**Example**  
```js
IgniteTemplate's construct method can be extended by adding a callback function to _constructors under a template:
template._constructors.push(() => console.log('constructed'));
```
**Example**  
```js
IgniteTemplate's deconstruct method can be extended by adding a callback function to _destructors under a template:
template._destructors.push(() => console.log('destructed'));
```
<a name="IgniteTemplate+class"></a>

### `igniteTemplate.class(name, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a CSS class to be added once this template is constructed.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>Name of the CSS class to add. Multiple CSS classes are supported if they are separated by a space.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can convert the class name into a different one.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
.class("row justify-content-center")
```
<a name="IgniteTemplate+attribute"></a>

### `igniteTemplate.attribute(name, value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a html element attribute to this template to be added once this template is constructed.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>The name of the attribute to add</p>
</td>
    </tr><tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code> | <code>function</code> | <code>Array.&lt;IgniteProperty&gt;</code></td><td></td><td><p>The value of the attribute to set, can be anything. If Property is passed it will auto update.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+value"></a>

### `igniteTemplate.value(value, reflect, converter, live)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the value of the element this template is constructing with the option to reflect changes
to the value.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set on the element.</p>
</td>
    </tr><tr>
    <td>reflect</td><td><code>Boolean</code> | <code>function</code></td><td><code>false</code></td><td><p>Whether or not to reflect changes to the value of the element back to the property if one was used. If function passed it will be invoked on value change. Default is false.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can convert the value if needed. Default is null.</p>
</td>
    </tr><tr>
    <td>live</td><td><code>Boolean</code></td><td><code>false</code></td><td><p>Whether or not to reflect the value in realtime, ie anytime the input is changed before focus is lost. Default is false.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+prop"></a>

### `igniteTemplate.prop(name, value, reflect, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets a property on the element this template will construct. (Shorthand for property())

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>Name of the property to set.</p>
</td>
    </tr><tr>
    <td>value</td><td><code>Any</code> | <code>IgniteProperty</code></td><td></td><td><p>Value of the property to use. If a Property is passed the value will auto update.</p>
</td>
    </tr><tr>
    <td>reflect</td><td><code>Boolean</code></td><td><code>false</code></td><td><p>If true whenever this property is changed it&#39;s value will be passed back to the Property that was passed as value if one was passed.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can be used to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+property"></a>

### `igniteTemplate.property(name, value, reflect, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets a property on the element this template will construct.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>Name of the property to set.</p>
</td>
    </tr><tr>
    <td>value</td><td><code>Any</code> | <code>IgniteProperty</code></td><td></td><td><p>Value of the property to use. If a Property is passed the value will auto update.</p>
</td>
    </tr><tr>
    <td>reflect</td><td><code>Boolean</code></td><td><code>false</code></td><td><p>If true whenever this property is changed it&#39;s value will be passed back to the Property that was passed as value if one was passed.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can be used to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+variable"></a>

### `igniteTemplate.variable(name, value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets a variable on the element this template will construct.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>Name of the variable to set</p>
</td>
    </tr><tr>
    <td>value</td><td><code>Any</code> | <code>IgniteProperty</code></td><td></td><td><p>Value of the variable to set</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can be used to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+reflect"></a>

### `igniteTemplate.reflect(name, target)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Makes a property on this template reflect its value back to the given target.
(You can reflect a property more than once if it's needed.)

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td><p>Name of the property to reflect.</p>
</td>
    </tr><tr>
    <td>target</td><td><code>IgniteProperty</code> | <code>function</code></td><td><p>The target for the value to be reflected to.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+properties"></a>

### `igniteTemplate.properties(props)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a set of properties from an object to be added to this template once it's constructed.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>props</td><td><code>Object</code> | <code>IgniteObject</code></td><td><p>The object value that property names/values will be pulled from.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+innerHTML"></a>

### `igniteTemplate.innerHTML(value, converter)` ⇒
Sets the inner html of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: This ignite template so funciton calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>InnerHTML to set for element. If a property is passed the html will auto update.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can be used to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+innerText"></a>

### `igniteTemplate.innerText(value, converter)` ⇒
Sets the inner text of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: This ignite template.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code> | <code>Array.&lt;IgniteProperty&gt;</code> | <code>function</code></td><td></td><td><p>text to be set for this element. If a property is passed the text will auto update.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function that can be used to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+child"></a>

### `igniteTemplate.child(...items)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a single or series of children to be added once this template
is constructed. Numbers, Strings, and Properties passed will be added as HTML child elements.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...items</td><td><code>Number</code> | <code>String</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+ref"></a>

### `igniteTemplate.ref(refCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a reference callback function to be invoked once this template is constructed. The function will be invoked
with the constructed HTMLElement. If an IgniteProperty is passed it's value will be set to the constructed HTMLElement once
the template is constructed.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>refCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback to be invoked with the HTMLElement of the element this template constructed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+on"></a>

### `igniteTemplate.on(eventName, eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds an event by its name and the function to invoke once the event fires. Properties may be used
for the function, but their value must be a valid function in order to get a proper event callback.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventName</td><td><code>String</code></td><td><p>The name of the event to add.</p>
</td>
    </tr><tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onClick"></a>

### `igniteTemplate.onClick(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a click event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onTouch"></a>

### `igniteTemplate.onTouch(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a touch event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onBlur"></a>

### `igniteTemplate.onBlur(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a onblur event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onFocus"></a>

### `igniteTemplate.onFocus(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a onfocus event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onChange"></a>

### `igniteTemplate.onChange(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a onchange event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onInput"></a>

### `igniteTemplate.onInput(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a oninput event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onPaste"></a>

### `igniteTemplate.onPaste(eventCallback)` ⇒
Adds a on paste event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: This ignite template.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked once the event fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onEnter"></a>

### `igniteTemplate.onEnter(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a on enter key press event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onBackspace"></a>

### `igniteTemplate.onBackspace(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a on backspace key press event handler to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onResize"></a>

### `igniteTemplate.onResize(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a special on resize event handler to this template that will
fire anytime the element is resized by using a resize observer. You can call this more than once to attach more than one callback.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onIntersect"></a>

### `igniteTemplate.onIntersect(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a special on intersect event handler to this template that will fire
once the element is in view. You can call this more than once to attach more than one callback.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked by the event once it fires.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+onSeen"></a>

### `igniteTemplate.onSeen(eventCallback)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a special event handler for this template that will fire the first time the element is seen and does not repeat.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>eventCallback</td><td><code>function</code> | <code>IgniteProperty</code></td><td><p>The callback function to be invoked once this element becomes visible.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+style"></a>

### `igniteTemplate.style(name, value, priority, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a CSS property to this template with a value and priority.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>The name of the CSS property to set.</p>
</td>
    </tr><tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the property. If an IgniteProperty is used it will auto update this style.</p>
</td>
    </tr><tr>
    <td>priority</td><td><code>String</code></td><td><code></code></td><td><p>If set to &quot;important&quot; then the style will be marked with !important. Acceptable values: important, !important, true, false, null</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>Optional function to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+hide"></a>

### `igniteTemplate.hide(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Hides the element this template is constructing if the value is true.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td><td><p>If true hides the element this template is constructing. If an IgniteProperty is passed it&#39;s value will auto update this.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+invisible"></a>

### `igniteTemplate.invisible(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Hides the element this template is constructing if the value is true.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td><td><p>If true hides the element this template is constructing. If an IgniteProperty is passed it&#39;s value will auto update this.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function to convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+show"></a>

### `igniteTemplate.show(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Shows the element this template is constructing if the value is true.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+visible"></a>

### `igniteTemplate.visible(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Shows the element this template is constructing if the value is true.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+id"></a>

### `igniteTemplate.id(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the id attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the id attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+title"></a>

### `igniteTemplate.title(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the title attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the title attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+for"></a>

### `igniteTemplate.for(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the for attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the for attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+role"></a>

### `igniteTemplate.role(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the role attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the for attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+checked"></a>

### `igniteTemplate.checked(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a checked attribute to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the checked attribute.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>*</code></td><td><code></code></td><td><p>Optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+disabled"></a>

### `igniteTemplate.disabled(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a disabled attribute and class to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td><td><p>A value to determine whether or not the element should be marked as disable or not.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>*</code></td><td><code></code></td><td><p>Optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+readonly"></a>

### `igniteTemplate.readonly(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Adds a readonly attribute and class to this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>Boolean</code> | <code>IgniteProperty</code></td><td></td><td><p>A value to determine whether or not the element should be marked as readonly or not.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>*</code></td><td><code></code></td><td><p>Optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+type"></a>

### `igniteTemplate.type(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the type attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the type attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+min"></a>

### `igniteTemplate.min(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the min attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the type attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+max"></a>

### `igniteTemplate.max(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the max attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the type attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+step"></a>

### `igniteTemplate.step(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the step attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the type attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+data"></a>

### `igniteTemplate.data(name, value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets a data attribute on the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>name</td><td><code>String</code></td><td></td><td><p>The name of the data attribute to set on the element this template will construct.</p>
</td>
    </tr><tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the data attribute of the element this template will construct.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>*</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+src"></a>

### `igniteTemplate.src(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the src attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the src attribute of the element to be constructed by this template.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+href"></a>

### `igniteTemplate.href(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the href attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the href attribute of the element to be constructed by this template.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+target"></a>

### `igniteTemplate.target(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the target attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the target attribute of the element to be constructed by this template.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+name"></a>

### `igniteTemplate.name(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the name attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the name attribute of the element to be constructed by this template.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+placeholder"></a>

### `igniteTemplate.placeholder(value, converter)` ⇒ [<code>IgniteTemplate</code>](#IgniteTemplate)
Sets the placeholder attribute of the element to be constructed by this template.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
**Returns**: [<code>IgniteTemplate</code>](#IgniteTemplate) - This ignite template so function calls can be chained.  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>value</td><td><code>String</code> | <code>IgniteProperty</code></td><td></td><td><p>The value to set for the placeholder attribute of the element.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>An optional function that can convert the value if needed.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+construct"></a>

### `igniteTemplate.construct(parent, sibling)`
Constructs this template and adds it to the DOM if this template
has not already been constructed.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>parent</td><td><code>HTMLElement</code></td><td><p>Parent element that will contain the constructed element.</p>
</td>
    </tr><tr>
    <td>sibling</td><td><code>HTMLElement</code></td><td><p>Optional sibling element that can be used to add the element adjacantly.</p>
</td>
    </tr>  </tbody>
</table>

<a name="IgniteTemplate+deconstruct"></a>

### `igniteTemplate.deconstruct()`
Deconstructs this template and cleans up all resources to make sure
there are no memory leaks.

**Kind**: instance method of [<code>IgniteTemplate</code>](#IgniteTemplate)  
<a name="div"></a>

## div
An ignite template that can be used to construct a div element.

**Kind**: global class  
<a name="new_div_new"></a>

### `new div(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="a"></a>

## a
An ignite template that can be used to construct a hyperlink element.

**Kind**: global class  
<a name="new_a_new"></a>

### `new a(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="input"></a>

## input
An ignite template that can be used to construct a input element.

**Kind**: global class  
<a name="new_input_new"></a>

### `new input(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="textarea"></a>

## textarea
An ignite template that can be used to construct a textarea element.

**Kind**: global class  
<a name="new_textarea_new"></a>

### `new textarea(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="button"></a>

## button
An ignite template that can be used to construct a button element.

**Kind**: global class  
<a name="new_button_new"></a>

### `new button(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h1"></a>

## h1
An ignite template that can be used to construct a h1 element.

**Kind**: global class  
<a name="new_h1_new"></a>

### `new h1(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h2"></a>

## h2
An ignite template that can be used to construct a h2 element.

**Kind**: global class  
<a name="new_h2_new"></a>

### `new h2(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h3"></a>

## h3
An ignite template that can be used to construct a h3 element.

**Kind**: global class  
<a name="new_h3_new"></a>

### `new h3(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h4"></a>

## h4
An ignite template that can be used to construct a h4 element.

**Kind**: global class  
<a name="new_h4_new"></a>

### `new h4(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h5"></a>

## h5
An ignite template that can be used to construct a h5 element.

**Kind**: global class  
<a name="new_h5_new"></a>

### `new h5(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="h6"></a>

## h6
An ignite template that can be used to construct a h6 element.

**Kind**: global class  
<a name="new_h6_new"></a>

### `new h6(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="hr"></a>

## hr
An ignite template that can be used to construct a hr element.

**Kind**: global class  
<a name="new_hr_new"></a>

### `new hr(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="p"></a>

## p
An ignite template that can be used to construct a p element.

**Kind**: global class  
<a name="new_p_new"></a>

### `new p(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="nav"></a>

## nav
An ignite template that can be used to construct a nav element.

**Kind**: global class  
<a name="new_nav_new"></a>

### `new nav(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="ul"></a>

## ul
An ignite template that can be used to construct a ul element.

**Kind**: global class  
<a name="new_ul_new"></a>

### `new ul(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="li"></a>

## li
An ignite template that can be used to construct a li element.

**Kind**: global class  
<a name="new_li_new"></a>

### `new li(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="span"></a>

## span
An ignite template that can be used to construct a span element.

**Kind**: global class  
<a name="new_span_new"></a>

### `new span(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="small"></a>

## small
An ignite template that can be used to construct a small element.

**Kind**: global class  
<a name="new_small_new"></a>

### `new small(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="strong"></a>

## strong
An ignite template that can be used to construct a strong element.

**Kind**: global class  
<a name="new_strong_new"></a>

### `new strong(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="i"></a>

## i
An ignite template that can be used to construct an i element.

**Kind**: global class  
<a name="new_i_new"></a>

### `new i(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="table"></a>

## table
An ignite template that can be used to construct a table element.

**Kind**: global class  
<a name="new_table_new"></a>

### `new table(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="td"></a>

## td
An ignite template that can be used to construct a td element.

**Kind**: global class  
<a name="new_td_new"></a>

### `new td(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="th"></a>

## th
An ignite template that can be used to construct a th element.

**Kind**: global class  
<a name="new_th_new"></a>

### `new th(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="tr"></a>

## tr
An ignite template that can be used to construct a tr element.

**Kind**: global class  
<a name="new_tr_new"></a>

### `new tr(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="thead"></a>

## thead
An ignite template that can be used to construct a thead element.

**Kind**: global class  
<a name="new_thead_new"></a>

### `new thead(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="tbody"></a>

## tbody
An ignite template that can be used to construct a tbody element.

**Kind**: global class  
<a name="new_tbody_new"></a>

### `new tbody(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="br"></a>

## br
An ignite template that can be used to construct a br element.

**Kind**: global class  
<a name="new_br_new"></a>

### `new br(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="img"></a>

## img
An ignite template that can be used to construct a img element.

**Kind**: global class  
<a name="new_img_new"></a>

### `new img(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="label"></a>

## label
An ignite template that can be used to construct a label element.

**Kind**: global class  
<a name="new_label_new"></a>

### `new label(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="select"></a>

## select
An ignite template that can be used to construct a select element.

**Kind**: global class  
<a name="new_select_new"></a>

### `new select(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="option"></a>

## option
An ignite template that can be used to construct a option element.

**Kind**: global class  
<a name="new_option_new"></a>

### `new option(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="script"></a>

## script
An ignite template that can be used to construct a script element.

**Kind**: global class  
<a name="new_script_new"></a>

### `new script(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="form"></a>

## form
An ignite template that can be used to construct a form element.

**Kind**: global class  
<a name="new_form_new"></a>

### `new form(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="header"></a>

## header
An ignite template that can be used to construct a header element.

**Kind**: global class  
<a name="new_header_new"></a>

### `new header(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="footer"></a>

## footer
An ignite template that can be used to construct a footer element.

**Kind**: global class  
<a name="new_footer_new"></a>

### `new footer(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="progress"></a>

## progress
An ignite template that can be used to construct a progress element.

**Kind**: global class  
<a name="new_progress_new"></a>

### `new progress(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="svg"></a>

## svg
An ignite template that can be used to construct a svg element.

**Kind**: global class  
<a name="new_svg_new"></a>

### `new svg(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="g"></a>

## g
An ignite template that can be used to construct a g element.

**Kind**: global class  
<a name="new_g_new"></a>

### `new g(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="path"></a>

## path
An ignite template that can be used to construct a path element.

**Kind**: global class  
<a name="new_path_new"></a>

### `new path(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="circle"></a>

## circle
An ignite template that can be used to construct a circle element.

**Kind**: global class  
<a name="new_circle_new"></a>

### `new circle(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="line"></a>

## line
An ignite template that can be used to construct a line element.

**Kind**: global class  
<a name="new_line_new"></a>

### `new line(...children)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>...children</td><td><code>String</code> | <code>Number</code> | <code>IgniteProperty</code> | <code><a href="#IgniteTemplate">IgniteTemplate</a></code></td><td><p>A series of children to be added to this template.</p>
</td>
    </tr>  </tbody>
</table>

<a name="text"></a>

## text
Text is a special template that will construct a text element and automatically update the dom
if it's content changes.

**Kind**: global class  
<a name="new_text_new"></a>

### `new text(text, converter)`
Constructs a text template with the text to render.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>text</td><td><code>String</code> | <code>IgniteProperty</code></td><td><p>The text to render within this text template.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><p>An optional function that can be used to convert the text.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
new text(`<script>Will show up as text</script>`)
```
<a name="html"></a>

## html
Html is a special template that can construct raw html or properties into the dom and automatically
update the dom if the property changes.

**Kind**: global class  
<a name="new_html_new"></a>

### `new html(code)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>code</td><td><code>String</code> | <code>IgniteProperty</code></td><td><p>HTML code to be constructed within this template. If an IgniteProperty is passed it&#39;s value will be used.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
new html(`<h1>Hello world!</h1>`)
```
<a name="list"></a>

## list
A special ignite template that constructs a list of items using a template
that is dynamically created for each item.

**Kind**: global class  
<a name="new_list_new"></a>

### `new list(list, forEachCallback, reflect)`
<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>list</td><td><code>Array</code> | <code>IgniteProperty</code></td><td></td><td><p>The list of items to construct within this template.</p>
</td>
    </tr><tr>
    <td>forEachCallback</td><td><code>function</code></td><td></td><td><p>A function that constructs a template foreach item.</p>
</td>
    </tr><tr>
    <td>reflect</td><td><code>Boolean</code></td><td><code>false</code></td><td><p>If true any items removed from the DOM will be removed from the list if they exist. By default this is false.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
new list(["1", "2", "3"], (item) => {
 return new h1(item);
})
```
<a name="slot"></a>

## slot
A slot template that mimicks the functionality of a slot element in Web Components. This can
be used to place children of a IgniteElement anywhere in the DOM. Slots don't actually construct an element,
they simply just place children in place where the slot was used. If classes, styles, or attributes are applied
to the slot they will be applied to the children of the slot.

**Kind**: global class  
<a name="new_slot_new"></a>

### `new slot(element)`
Creates a new slot with the element who's children will be injected.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>element</td><td><code>IgniteElement</code></td><td><p>The parent IgniteElement that this slot is for.</p>
</td>
    </tr>  </tbody>
</table>

**Example**  
```js
//You must pass the ignite element who owns the slot of the first param.
new slot(this)
```
**Example**  
```js
//Slots can apply classes, attributes, and styles to children within the slot
new slot(this).class("active") //< Would apply .active to all children
```
**Example**  
```js
//You can also use properties to have dynamic classes, styles, or attributes on slot children
new slot(this).class(this.someClass)
```
<a name="pagination"></a>

## pagination
A pagination is a template that segments a list of items into pages based
on the items, page size, current page.

**Kind**: global class  
<a name="new_pagination_new"></a>

### `new pagination(list, pageSize, currentPage, forEach)`
Constructs a new pagination with all the settings needed.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>list</td><td><code>Array</code> | <code>IgniteProperty</code></td><td><p>The list of items to paginate.</p>
</td>
    </tr><tr>
    <td>pageSize</td><td><code>Number</code> | <code>IgniteProperty</code></td><td><p>The size of each page.</p>
</td>
    </tr><tr>
    <td>currentPage</td><td><code>Number</code> | <code>IgniteProperty</code></td><td><p>The current page to display.</p>
</td>
    </tr><tr>
    <td>forEach</td><td><code>function</code></td><td><p>The render function foreach item in the list.</p>
</td>
    </tr>  </tbody>
</table>

<a name="pager"></a>

## pager
A pager is a template that converts pagination information into elements
to form a page selection.

**Kind**: global class  

* [pager](#pager)
    * [`new pager(items, pageSize, currentPage, pageRange, renderCallback)`](#new_pager_new)
    * [`.items`](#pager+items) : <code>Number</code> \| <code>Array</code> \| <code>IgniteProperty</code>
    * [`.pageSize`](#pager+pageSize) : <code>Number</code> \| <code>IgniteProperty</code>
    * [`.currentPage`](#pager+currentPage) : <code>Number</code> \| <code>IgniteProperty</code>
    * [`.pageRange`](#pager+pageRange) : <code>Number</code> \| <code>IgniteProperty</code>
    * [`.pageCount`](#pager+pageCount) : <code>Number</code>
    * [`.pages`](#pager+pages) : [<code>Array.&lt;IgniteTemplate&gt;</code>](#IgniteTemplate)
    * [`.renderCallback`](#pager+renderCallback) : <code>function</code>

<a name="new_pager_new"></a>

### `new pager(items, pageSize, currentPage, pageRange, renderCallback)`
Constructs a new pager with all the settings needed.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>items</td><td><code>Number</code> | <code>Array</code> | <code>IgniteProperty</code></td><td><p>The items to construct pages for.</p>
</td>
    </tr><tr>
    <td>pageSize</td><td><code>Number</code> | <code>IgniteProperty</code></td><td><p>The number of items to show per page.</p>
</td>
    </tr><tr>
    <td>currentPage</td><td><code>Number</code> | <code>IgniteProperty</code></td><td><p>The current page being shown.</p>
</td>
    </tr><tr>
    <td>pageRange</td><td><code>Number</code> | <code>IgniteProperty</code></td><td><p>The number of pages that can be selected at a time. 3 is typically chosen.</p>
</td>
    </tr><tr>
    <td>renderCallback</td><td><code>function</code></td><td><p>Render function for a page, pageIndex is the index of the page, current is whether or not this is the current page, dots is whether this render is for dots.</p>
</td>
    </tr>  </tbody>
</table>

<a name="pager+items"></a>

### `pager.items` : <code>Number</code> \| <code>Array</code> \| <code>IgniteProperty</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+pageSize"></a>

### `pager.pageSize` : <code>Number</code> \| <code>IgniteProperty</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+currentPage"></a>

### `pager.currentPage` : <code>Number</code> \| <code>IgniteProperty</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+pageRange"></a>

### `pager.pageRange` : <code>Number</code> \| <code>IgniteProperty</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+pageCount"></a>

### `pager.pageCount` : <code>Number</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+pages"></a>

### `pager.pages` : [<code>Array.&lt;IgniteTemplate&gt;</code>](#IgniteTemplate)
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="pager+renderCallback"></a>

### `pager.renderCallback` : <code>function</code>
**Kind**: instance property of [<code>pager</code>](#pager)  
<a name="population"></a>

## population
An ignite template that can construct a population of items
based on a count.

**Kind**: global class  
<a name="new_population_new"></a>

### `new population(count, forEach, converter)`
Creates a new population with the number of items in it, a converter if needed, and a foreach function.

<table>
  <thead>
    <tr>
      <th>Param</th><th>Type</th><th>Default</th><th>Description</th>
    </tr>
  </thead>
  <tbody>
<tr>
    <td>count</td><td><code>Number</code> | <code>IgniteProperty</code> | <code>Array.&lt;IgniteProperty&gt;</code></td><td></td><td><p>The number of items in this population.</p>
</td>
    </tr><tr>
    <td>forEach</td><td><code>function</code></td><td></td><td><p>A function to generate items in the population.</p>
</td>
    </tr><tr>
    <td>converter</td><td><code>function</code></td><td><code></code></td><td><p>A converter to be used to convert the count if needed.</p>
</td>
    </tr>  </tbody>
</table>

